/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2002 Muli Ben-Yehuda, mulix@actcom.co.il      */
/* License: GNU General Public License                              */

/*
 * $Id: log_dev.h,v 1.4 2002/08/04 03:33:49 mulix Exp $
 */ 

#ifndef LOG_DEV_H_
#define LOG_DEV_H_

#include "membuf.h"
#include "sct_compat.h"

typedef struct sct_log_dev_type {
	sct_membuf_t* ring; 
	wait_queue_head_t wait;	
} sct_log_dev_t;

int init_log_dev_file(sct_log_dev_t** dev); 

void destroy_log_dev_file(sct_log_dev_t* dev); 

void wake_up_logger(void); 

extern sct_log_dev_t log_dev; 

#endif /* CTRL_DEV_H_ */ 
