/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2002 guy keren, choo@actcom.co.il             */
/* License: GNU General Public License                              */

/*
 * $Id: util.h,v 1.3 2002/08/12 12:20:56 mulix Exp $
 */ 

#ifndef UTIL_H_
#define UTIL_H_

/* set (*kernel_str) to point to a kernel space copy of the    */
/* string 'str'. return 0 on success, negative errno on error. */ 
int getstring(const char* str, char** kern_str);

/* free a string gotten from getstring */
#define putstring(name)   kfree((name))

/* see module_main.c */ 
extern unsigned long debug_level; 

/* different debug levels. higher levels include lower level messages */ 
#define DEB_INFO (1)
#define DEB_DEV_FILE (2)
#define DEB_SYSCTL (2)
#define DEB_MISC (3)
#define DEB_LOCK (3)

#ifdef SCT_MODULE_DEBUG

#define SCTDBG(level, msg, args...) do {                                  \
        if (debug_level >= level)                                         \
                printk(KERN_DEBUG "[%s] " msg , __FUNCTION__ , ##args );  \
} while (0)

#else /* !defined(SCT_MODULE_DEBUG) */ 

#define SCTDBG(level, msg, args...) do { } while (0)

#endif /* SCT_MODULE_DEBUG */ 

#endif /* UTIL_H_ */
