/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2002 Muli Ben-Yehuda, mulix@actcom.co.il      */
/* License: GNU General Public License                              */

/* 
 * $Id: tester.h,v 1.18 2002/07/29 21:46:58 mulix Exp $
 */ 

#ifndef TESTER_H_
#define TESTER_H_

#include <stdio.h>

#include "tests.h" 

void fatal(const char* func, const char* file,
	   unsigned int line, const char* fmt, ...);

void logerror(const char* func, const char* file,
	      unsigned int line, const char* fmt, ...);

#define die(format, args...) \
	fatal(__FUNCTION__,__FILE__,__LINE__, format , ## args)
#define logerr(format, args...) \
	logerror(__FUNCTION__,__FILE__,__LINE__, format , ## args)

#define CHECK(check, expect) do {                                     \
	int res = check;                                              \
        if (expect != res) {                                          \
	        fprintf(stdout, "CHECK FAILED: %s returned %d, "      \
			"expected %d\n", #check , res, (int) expect); \
        }                                                             \
} while (0)                                                           \

#endif /* TESTER_H_ */
